SystemOrganization addCategory: #GraphicsSystemSettings!

Object subclass: #GraphicsSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphicsSystemSettings'!

!GraphicsSystemSettings classSide methodsFor: 'settings' stamp: 'AlainPlantec 1/10/2010 22:04'!
depthChoices
	| oldDepth allDepths hasBoth allLabels | 
	oldDepth := Display nativeDepth.
	allDepths := #(1 -1 2 -2 4 -4 8 -8 16 -16 32 -32 )
				select: [:d | Display supportsDisplayDepth: d].
	hasBoth := (allDepths anySatisfy: [:d | d > 0]) and: [allDepths anySatisfy: [:d | d < 0]].
	allLabels := allDepths
				collect: [:d | String
						streamContents: [:s | 
							s print: d abs.
							hasBoth
								ifTrue: [s
										nextPutAll: (d > 0
												ifTrue: ['  (big endian)']
												ifFalse: ['  (little endian)'])]]].
	^ (allLabels with: allDepths collect: [:l :d | l -> d]) asArray sort: [:a :b | a value < b value]
! !

!GraphicsSystemSettings classSide methodsFor: 'settings' stamp: 'AlainPlantec 1/10/2010 08:19'!
displaySettingsOn: aBuilder 
	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Display depth' translated;
		parent: #appearance;
		target: #Display; 
		getSelector: #depth;
		setSelector: #newDepth:;
		domainValues: self depthChoices;
		notInStyle.
	(aBuilder setting: #displayFullscreen)
		label: 'Fullscreen mode' translated;
		parent: #desktopSettings;
		target: #Display;
		getSelector: #isFullScreen;
		setSelector: #fullScreen:;
		description: 'On platforms that support it, set full-screen mode' translated;
		default: false.
! !

!GraphicsSystemSettings classSide methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 09:26'!
installDejaVu 
	StrikeFont installDejaVu.
	SettingBrowser refreshAllSettingBrowsers

! !

!GraphicsSystemSettings classSide methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 09:37'!
installDejaVuSettingOn: aBuilder 
	<systemsettings>
	(aBuilder launcher: #'Install bitmap DejaVu fonts') 
		order: -999; 
		 parent: #standardFonts;
		 target: self;
		 script: #installDejaVu.
! !

!GraphicsSystemSettings classSide methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 08:15'!
resetAllFontToDefault
	StandardFonts setAllStandardFontsTo: StandardFonts defaultFont.
	SettingBrowser refreshAllSettingBrowsers
	 
! !

!GraphicsSystemSettings classSide methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 08:15'!
resetAllFontToDefaultButton
			^ (UITheme current
				newButtonIn: World 
				for: self
				getState: nil
				action: #resetAllFontToDefault
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: 'Set all predefined system fonts to the default one' translated)
		 		label: (UITheme current newRowIn: World for: {AlphaImageMorph new image: MenuIcons smallRedoIcon. UITheme current buttonLabelForText: 'Reset all to default' translated});
		 		yourself.
! !

!GraphicsSystemSettings classSide methodsFor: 'fonts' stamp: 'AlainPlantec 1/10/2010 09:29'!
standardFontsSettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #standardFonts)
		label: 'Standard fonts' translated;
		target: StandardFonts;
		parent: #appearance;
		order: 4;
		with: [ 
			(aBuilder launcher: #updateFromSystem)
				order: 1; 
				target: FreeTypeFontProvider;
				targetSelector: #current;
				description: 'Update available fonts by scaning the current system';
				script: #updateFromSystem;
				label: 'Update fonts from system' translated.
			(aBuilder setting: #defaultFont)
				description: 'The default text font' translated;
				dialog: (MessageSend receiver: self selector: #resetAllFontToDefaultButton);
				label: 'Default' translated.
			(aBuilder setting: #codeFont) 
				description: 'The standard code font' translated;
				label: 'Code' translated.
			(aBuilder setting: #listFont)
				description: 'The standard list font' translated;
				label: 'List' translated.
			(aBuilder setting: #menuFont)
				description: 'The standard menu font' translated;
				label: 'Menu' translated.
			(aBuilder setting: #buttonFont)
				description: 'The standard button font' translated;
				label: 'Button' translated.
			(aBuilder setting: #windowTitleFont)
				description: 'The standard window title font' translated;
				label: 'Window title' translated.
			(aBuilder setting: #balloonFont)
				description: 'The standard balloon-help font' translated;
				label: 'Balloon-help' translated.
			(aBuilder setting: #haloFont)
				description: 'The morphic halo font' translated;
				label: 'Morphic halo' translated]
				
				! !
